'=============================================================================
' Copyright  Micromega Corporation 2005-2007. All rights reserved.
'
' @file		template-i2c.bsp
' @target	PicBasic Pro
'
' This program provides an example of using the uM-FPU V3.1 floating point
' coprocessor with the PICBASIC PRO compiler using an I2C interface. It shows
' the initial FPU reset sequence and prints the version number of the FPU chip.
'
' @author Cam Thompson, Micromega Corporation
' @version
'	October 11, 2007
'	- original version
'=============================================================================

'-------------------- PIC oscillator speed ------------------------------------
define      OSC 20                      ' specify the speed of the oscillator
OSC_SPEED   con 20                      ' define PicBasic constant

'-------------------- debug definitions ---------------------------------------
define      DEBUG_REG   PORTC
define      DEBUG_BIT   6
define      DEBUG_BAUD  19200
define      DEBUG_MODE  0

'-------------------- uM-FPU pin definitions ----------------------------------
Fpu_SCL     var     PORTC.3             ' I2C SCL pin (uM-FPU SCL)
Fpu_SDA     var     PORTC.4             ' I2C SDA pin (uM-FPU SDA)
Fpu_ID      con     $C8                 ' uM-FPU I2C device address
define      I2C_HOLD    1               ' required for correct I2C timing

include     "umfpuV3-i2c.bas"           ' include the uM-FPU V3 support routines

'-------------------- uM-FPU register definitions ----------------------------


'-------------------- variables ----------------------------------------------


'=============================================================================
'-------------------- initialization -----------------------------------------
'=============================================================================

Reset:
  DEBUG 13, 10, 13, 10, "I2C template", 13, 10

  GOSUB Fpu_Reset                       ' initialize uM-FPU
  IF fpu_status <> SYNC_CHAR THEN
    DEBUG "uM-FPU not detected."
    END
  ELSE
    GOSUB Print_Version                 ' display version string
	DEBUG 13, 10
  ENDIF

'=============================================================================
'-------------------- main routine -------------------------------------------
'=============================================================================

Main:
'	Insert main application code here.
'	FPU instructions are sent using an SHIFTOUT instruction.
'	e.g.
'		I2CWRITE Fpu_SDA, Fpu_SCL, Fpu_ID, 0, [SELECTA, 1, LOADPI, FSET0]

Done:
	DEBUG 13, 10, "Done.", 13, 10
	END
